from arkindex.project.openapi.hooks import check_tags, operation_id_pascal_case, request_body_x_name  # noqa: F401
from arkindex.project.openapi.schema import AutoSchema  # noqa: F401
from arkindex.project.openapi.views import OpenApiSchemaView  # noqa: F401

# A JSON Schema that allows either an UUID or `False`, to allow worker version filters to use both version IDs
# or `False` for worker_version=None.
# None/null should not be used as filter values, as those might translate to empty strings, be ignored by OpenAPI
# clients, HTTP clients or even by our own code.
UUID_OR_FALSE = {
    'oneOf': [
        {'type': 'string', 'format': 'uuid'},
        # JSON Schema Draft 6 introduced `const` for constants, but OpenAPI 3.0.3 does not support it.
        # We use an enum instead to specify that we only accept False, not True.
        {'type': 'boolean', 'enum': [False]},
    ]
}

# A JSON Schema that allows either an UUID or a string, to allow filtering by either an ID or a slug, for example
# when filtering by worker type.
UUID_OR_STR = {
    'oneOf': [
        {'type': 'string', 'format': 'uuid'},
        {'type': 'string'},
    ]
}
